"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.of = of;
const Result_1 = require("../../Result");
const helpers_1 = require("../helpers");
function of(func) {
    return __awaiter(this, void 0, void 0, function* () {
        const result = new Result_1.Result();
        yield (0, helpers_1.runInTry)(() => __awaiter(this, void 0, void 0, function* () {
            result.setValue(yield func());
        }), result);
        return result;
    });
}
